from active_bo_msgs.srv import ActiveRL

import rclpy
from rclpy.node import Node

import numpy as np
import time


class ActiveRLTest(Node):
    def __init__(self):
        super().__init__('active_rl_test')

        self.client = self.create_client(ActiveRL, 'active_rl_srv')

        self.main_loop = self.create_timer(20.0, self.main_callback)

    def main_callback(self):

        random_policy = np.random.uniform(-1.0, 1.0, 100).tolist()
        random_weights = np.random.uniform(-1.0, 1.0, 5).tolist()

        self.get_logger().info(str(random_policy))

        rl_request = ActiveRL.Request()
        rl_request.old_policy = random_policy
        rl_request.old_weights = random_weights

        future = self.client.call_async(rl_request)

        self.get_logger().info(str(future))


def main(args=None):
    rclpy.init(args=args)

    active_rl_test = ActiveRLTest()

    rclpy.spin(active_rl_test)

    rclpy.shutdown()


if __name__ == '__main__':
    main()
