from launch import LaunchDescription
from launch.actions import IncludeLaunchDescription
from launch.launch_description_sources import PythonLaunchDescriptionSource
from launch_ros.actions import Node

from ament_index_python import get_package_share_directory
import os


def generate_launch_description():
    websocket_launch = IncludeLaunchDescription(
        PythonLaunchDescriptionSource(
            os.path.join(
                get_package_share_directory('active_bo_ros'),
                'rosbridge_server.launch.py'
            )
        )
    )
    rl_launch = IncludeLaunchDescription(
        PythonLaunchDescriptionSource(
            os.path.join(
                get_package_share_directory('active_bo_ros'),
                'rl_service.launch.py'
            )
        )
    )
    bo_launch = IncludeLaunchDescription(
        PythonLaunchDescriptionSource(
            os.path.join(
                get_package_share_directory('active_bo_ros'),
                'bo_service.launch.py'
            )
        )
    )
    arl_launch = Node(
        package='active_bo_ros',
        executable='active_rl_srv',
        name='active_rl_service',
        remappings=[
            ('active_rl_srv', 'arl_proxy')
        ],
    )
    abo_launch = Node(
        package='active_bo_ros',
        executable='active_bo_srv',
        name='active_bo_service',
        remappings=[
            ('active_bo_srv', 'abo_proxy')
        ],
    )
    return LaunchDescription([
        websocket_launch,
        rl_launch,
        bo_launch,
        arl_launch,
        abo_launch
    ])
