import numpy as np


class ImprovementQuery:
    def __init__(self, threshold, period, last_query, rewards):
        self.threshold = threshold
        self.period = period
        self.last_query = last_query
        self.rewards = rewards

    def query(self):
        if self.rewards.shape[0] < self.period + 1:
            return False

        elif self.rewards.shape[0] < self.last_query + self.period + 1:
            return False

        else:
            first = self.rewards[-self.period-1]
            last = self.rewards[-1]

            slope = (last - first) / self.period

            return slope < self.threshold
