from launch import LaunchDescription
from launch.actions import IncludeLaunchDescription
from launch.launch_description_sources import PythonLaunchDescriptionSource

from ament_index_python import get_package_share_directory
import os


def generate_launch_description():
    websocket_launch = IncludeLaunchDescription(
        PythonLaunchDescriptionSource(
            os.path.join(
                get_package_share_directory('active_bo_ros'),
                'rosbridge_server.launch.py'
            )
        )
    )

    # rl_launch = IncludeLaunchDescription(
    #     PythonLaunchDescriptionSource(
    #         os.path.join(
    #             get_package_share_directory('active_bo_ros'),
    #             'rl_service.launch.py'
    #         )
    #     )
    # )

    bo_launch = IncludeLaunchDescription(
        PythonLaunchDescriptionSource(
            os.path.join(
                get_package_share_directory('active_bo_ros'),
                'bo_service.launch.py'
            )
        )
    )

    return LaunchDescription([
        websocket_launch,
        # rl_launch,
        bo_launch
    ])
